//
//  NSArrayExtensions.h
//  Malkinware
//
//  Created by Jim McGowan on 14/10/2007.
//  Copyright 2007 Jim McGowan. All rights reserved.
//

#import <Foundation/Foundation.h>


@interface NSArray (MWNSArrayExtensions)

- (id)firstObject;
- (id)firstObjectMatchingPredicate:(NSPredicate *)predicate;
- (id)firstObjectWithValueMatching:(id)value forKey:(id)key;

- (BOOL)containsObjectWithValuesForKeys:(NSArray *)keys matchingObject:(id)testObject;

- (BOOL)isEmpty;
- (BOOL)isNotEmpty;

- (void)addObserverToAllObjects:(NSObject *)anObserver forKeyPath:(NSString *)keyPath options:(NSKeyValueObservingOptions)options context:(void *)context;
- (void)removeObserverFromAllObjects:(NSObject *)anObserver forKeyPath:(NSString *)keyPath;

- (NSArray *)sortedArrayUsingIntegerProperty:(id)integerPropertyKey ascending:(BOOL)ascending;
- (NSArray *)sortedArrayUsingStringProperty:(id)stringPropertyKey options:(NSStringCompareOptions)optionsMask ascending:(BOOL)ascending;

- (NSArray *)filteredArrayUsingBlock:(BOOL (^)(id evaluatedObject))block;

@end
